// #autoload
// #name = SimpleTeamTV
// #include = support/callback.cs
// #include = support/kill_callbacks.cs
// #include = support/player_support.cs
// #include = support/team_tracker.cs
// #category = ilys' Scripts

package SimpleTeamTV
{
	function OptionsDlg::onWake(%this)
	{
		if (!$TVMenuBindLoaded)
		{
			$RemapName[$RemapCount] = "SimpleTeamTV Menu";
			$RemapCmd[$RemapCount] = "activateTVMenuHud";
			$RemapCount++;
			$RemapName[$RemapCount] = "SimpleTeamTV Obs Flag Carrier";
			$RemapCmd[$RemapCount] = "activateTVCarrier";
			$RemapCount++;
			$RemapName[$RemapCount] = "SimpleTeamTV Check Flag Carrier";
			$RemapCmd[$RemapCount] = "activateTVCheckCarrier";
			$RemapCount++;
			$TVMenuBindLoaded = true;
		}
		parent::onWake(%this);
	}
	function CommanderMapGui::onWake(%this)
	{
		$TVClientID = "";
		$TVTargetName = "";
		CommanderTV.attached = 0;
		clientCmdClearBottomPrint();
		schedule(150, 0, setFov, $pref::player::defaultfov);
		parent::onWake(%this);
	}
	function clientCmdSetPilotVehicleKeys()
	{
		parent::clientCmdSetPilotVehicleKeys();
		passengerKeys.copyBind( moveMap, activateTVMenuHud );
		passengerKeys.copyBind( moveMap, activateTVCarrier );
		passengerKeys.copyBind( moveMap, activateTVCheckCarrier );
	}
	function clientCmdSetPassengerVehicleKeys()
	{
		parent::clientCmdSetPassengerVehicleKeys();
		passengerKeys.copyBind( moveMap, activateTVMenuHud );
		passengerKeys.copyBind( moveMap, activateTVCarrier );
		passengerKeys.copyBind( moveMap, activateTVCheckCarrier );
	}
	function PlayGui::onWake(%this)
	{
		callback.add(CallbackMsgCTFFlagTaken, "CheckFlagTaken");
		callback.add(CallbackMsgCTFFlagDropped, "CheckFlagDrop");
		callback.add(CallbackMsgCTFFlagReturned, "CheckFlagDrop");
		callback.add(CallbackMsgCTFFlagCapped, "CheckFlagDrop");
		callback.add(CallbackMsgMissionStart, "TargetIDLoad");
		callback.add(killcallback, "CheckPlayerDeath");
		parent::onWake(%this);
		if(!isObject(TVMenuHudDlg))
		{
			new GuiControl(TVMenuHudDlg)
			{
				profile = "GuiDefaultProfile";
				horizSizing = "width";
				vertSizing = "height";
				position = "0 0";
				extent = "640 480";
				minExtent = "8 8";
				visible = "0";
				hideCursor = "0";
				bypassHideCursor = "1";
				new ShellFieldCtrl(TVMenuHud)
				{
					profile = "GuiVMenuProfile";
					horizSizing = "right";
					vertSizing = "top";
					position = "8 100";
					extent = "143 0";
					minExtent = "8 8";
					visible = "1";
				};
			};
			if(isObject(HM) && isObject(HudMover)) hudmover::addhud(TVMenuHud, "TV Menu");
		}
	}
};
activatePackage(SimpleTeamTV);
function doTVPlayerMenu()
{
	if(isObject(TVMenuRoot))
	{
		$RootTVMenu.pop();
		$RootTVMenu.delete();
	}
	$RootTVMenu = new ActionMap(TVMenuRoot);
	$RootTVMenu.bindCmd(keyboard,escape,"cancelTVMenu();","");
	$RootTVMenu.optionCount = 0;
	%char = "ABCDEFGHIJKLMNOPQRSTUVWQYZ";
	%i = 0;
	%team1count = 0;
	%players = PlayerListGroup.getCount();
	while(%i < %players)
	{
		%obj = PlayerListGroup.getObject(%i);
		if(%obj.teamId == teamtracker.friendlyTeamID)
		{
			%key = getSubStr(%char, %team1count, 1 );
			addTV(%key, %obj.clientid, %obj.name);
			%team1count++;
		}
		%i++;
	}
	%key = getSubStr(%char, %team1count, 1);
	addTV("Z", -1, "\c2None");
	%team1count++;
}
function activateTVCarrier(%make)
{
	if(!%make) return;
	if($TVFlagCarrierName $= "") return;
	if(CommanderTV.attached) TVPlayer(-1);
	else TVPlayer($TVFlagCarrierClientID, $TVFlagCarrierName);
}
function activateTVCheckCarrier(%make)
{
	if($TVFlagCarrierName $= "") return;
	if(%make) TVPlayer($TVFlagCarrierClientID, $TVFlagCarrierName);
	else TVPlayer(-1);
}
function CheckFlagTaken(%msgType, %msgString, %clientName, %flagTeam, %flagTeamId, %clientNameBase)
{
	%name = detag(%clientName);
	%ClientID = PlayerList.getIDByName(%name);
	if(%flagTeamId == teamtracker.enemyTeamID)
	{
		$TVFlagCarrierName = %name;
		$TVFlagCarrierClientID = %ClientID;
	}
}
function CheckFlagDrop(%msgType, %msgString, %clientName, %flagTeam, %flagTeamId)
{
	%name = detag(%clientName);
	%ClientID = PlayerList.getIDByName(%name);
	if(%ClientID == $TVFlagCarrierClientID && %ClientID == $TVClientID) TVPlayer(-1);
	if(%flagTeamId == teamtracker.enemyTeamID)
	{
		$TVFlagCarrierName = "";
		$TVFlagCarrierClientID = "";
	}
}
function CheckPlayerDeath(%msgtype, %killerRef, %victimRef, %weapon, %i_die, %i_win, %suicide, %tk)
{
	if(%victimRef.clientid != $TVFlagCarrierClientID && %victimRef.clientid == $TVClientID) $RefreshObs = schedule(5000, 0, TVPlayer, $TVClientID, $TVTargetName);
}
function TVPlayer(%ClientID, %name)
{
	if($RefreshObs !$= "") cancel($RefreshObs);
	if(%ClientID != -1)
	{
		%TargetID = $PlayerList[%ClientID].targetid;
		$TVClientID = %ClientID;
		$TVTargetName = %name;
		commandToServer('AttachCommanderCamera', %targetId);
		clientCmdBottomPrint("You are now observing:\n "@%name, 0, 2);
		if(!isObject($TVPlayer))
		{
			$TVPlayer = new ActionMap();
			$TVPlayer.bindCmd(mouse0,"button0","TVPlayer(-1);","");
			$TVPlayer.bindCmd(mouse0,"button1","TVPlayer($TVClientID, $TVTargetName);","");
		}
		$TVPlayer.push();
	}
	else
	{
		$TVClientID = "";
		$TVTargetName = "";
		commandToServer('ResetControlObject');
		CommanderTV.attached = 0;
		clientCmdClearBottomPrint();
		schedule(150, 0, setFov, $pref::player::defaultfov);
		$TVPlayer.pop();
	}
	cancelTVMenu();
}
function addTV(%key, %clientid, %name)
{
	$RootTVMenu.bindCmd(keyboard, %key, "", "TVPlayer(" @ %clientid @ ", \"" @ %name @ "\");");
	$RootTVMenu.option[$RootTVMenu.optionCount] = %key @ ": " @ %name;
	$RootTVMenu.optionCount++;
}
function activateTVMenuHud(%make)
{
	if(!%make) return;
	doTVPlayerMenu();
	showTVMenuHud();
	setTVMenu();
}
function showTVMenuHud()
{
	$RootTVMenu.push();
	Canvas.pushDialog(TVMenuHudDlg);
	TVMenuHudDlg.setVisible(true);
}
function cancelTVMenu()
{
	$RootTVMenu.pop();
	Canvas.popDialog(TVMenuHudDlg);
	TVMenuHudDlg.setVisible(false);
}
function setTVMenu()
{
	for(%i = 0; %i < $TVMenuHudLineCount; %i++ ) TVMenuHud.remove( $TVMenuHudText[%i]);
	$TVMenuHudLineCount = $RootTVMenu.optionCount + 1;
	TVMenuHud.extent = "170" SPC ($TVMenuHudLineCount * 15) + 8;
	$TVMenuHudText[0] = new GuiTextCtrl()
	{
		profile = "GuiHudVoiceMenuProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "5 3";
		extent = "165 20";
		minExtent = "8 8";
		visible = "1";
		text = "\c2Menu:";
	};
	TVMenuHud.add($TVMenuHudText[0]);
	for(%option = 0; %option < $RootTVMenu.optionCount; %option++)
	{
		%yOffset = (%option * 15) + 18;
		$TVMenuHudText[%option + 1] = new GuiTextCtrl()
		{
			profile = "GuiHudVoiceCommandProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 " @ %yOffset;
			extent = "165 20";
			minExtent = "8 8";
			visible = "1";
			text = "  " @ $RootTVMenu.option[%option];
		};
		TVMenuHud.add($TVMenuHudText[%option + 1]);
	}
}
